// NEBULA calibration class
// 

#ifndef _TARTCALIBNEBULA_H_
#define _TARTCALIBNEBULA_H_

#include <TNamed.h>
#include <vector>
#include <map>

class TClonesArray;
typedef TClonesArray TArtNEBULAPlaArray;
class TArtNEBULAPla;
class TArtNEBULAPlaPara;
typedef TClonesArray TArtNEBULAPlaParaArray;
class TArtNEBULAParameters;
class TArtStoreManager;

class TString;

class TArtCalibNEBULA
{
public:
  TArtCalibNEBULA();
  virtual ~TArtCalibNEBULA();

  void LoadRawData();
  void ReconstructData();
  void ClearData();

  bool IsReconstructed(){return fReconstructed;}

  Int_t GetNumNEBULAPla() const;
  TArtNEBULAPla* GetNEBULAPla(int i) const;
  TArtNEBULAPla* FindNEBULAPla(int id) const;//find by id
  TArtNEBULAPlaArray* GetNEBULAPlaArray() const;
  Int_t GetNumNEBULAPlaPara() const;
  TArtNEBULAPlaPara* GetNEBULAPlaPara(int i) const;
  TArtNEBULAPlaPara* FindNEBULAPlaPara(int id) const;//find by id
  TArtNEBULAPlaParaArray* GetNEBULAPlaParaArray() const;

private:
  bool fReconstructed;

  TArtNEBULAPlaArray* fNEBULAPlaArray;
  TArtNEBULAPlaParaArray* fNEBULAPlaParaArray;

  const TArtNEBULAParameters* fNEBULAParameters;

  TArtStoreManager* fStoreManager;

  std::map<int,int> fIDNPlaMap;  //for optimize
  std::map<int,int> fIDNPlaParaMap;  //for optimize

  ClassDef(TArtCalibNEBULA,1);
};

#endif
